
QGIS Application - Bug report #21086

Can't add a virtual field or update a existing field of a WFS layer using the field calculator

2019-01-24 11:52 AM - Bo Thomsen

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti

Category: Web Services clients/WFS

Affected QGIS version:3.5(master) Regression?: No

Operating System: Any Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 28904

Description

If you try to add a virtual field to a WFS based layer using the field calculator it will fail and show "NULL" regardless what expression you

use in the created field.

Further, it's not possible to set the type or field length for the virtual field because the relevant combo boxes in the dialog are disabled.

Lastly, you can't update a existing field using the field calculator (The wfs can however by edited manually in the attribute dialog)

Associated revisions

Revision 57d32939 - 2019-01-25 05:24 PM - Alessandro Pasotti

Field calculator: provide a list of default field types

in case the provider does not (WFS is one of them).

Rationale: consider that there is not such

a thing like a list of supported types for WFS

and parsing the particular describeFeatureType

for the layer would restrict the types to only

those actually existing in the layer, but

we are dealing with virtual fields here (because

WFS has no column add capabilities) so

let's give the users a minimal set of useful

types to play with.

Fixes #21086

History

#1 - 2019-01-24 11:59 AM - Alessandro Pasotti

- Category changed from Field calculator to Web Services clients/WFS

Changing category to WFS because I assume that all of this is working correctly with the other provider, or not?

#2 - 2019-01-24 03:21 PM - Bo Thomsen

Yes, I exported one of the wfs-datasources to a shapefile and retried the experiment. It worked as epected with the shapefile based data.
#3 - 2019-01-24 04:43 PM - Alessandro Pasotti

- Assignee deleted (Bo Thomsen)

#4 - 2019-01-25 09:38 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#5 - 2019-01-25 04:18 PM - Alessandro Pasotti

- Resolution set to worksforme

- Status changed from Open to Feedback

Next time please file separate tickets for separate issues, even if in this particular case my first answer is the same.

1 - If you try to add a virtual field to a WFS based layer using the field calculator it will fail and show "NULL" regardless what expression you use in the

created field.

I cannot reproduce with current master on Linux (but I doubt that the OS makes any difference).

2 - Further, it's not possible to set the type or field length for the virtual field because the relevant combo boxes in the dialog are disabled.

I cannot reproduce with current master on Linux (but I doubt that the OS makes any difference).

3 - Lastly, you can't update a existing field using the field calculator (The wfs can however by edited manually in the attribute dialog)

I cannot reproduce with current master on Linux (but I doubt that the OS makes any difference).

Cna you please test current master?

#6 - 2019-01-25 04:23 PM - Alessandro Pasotti

- Resolution deleted (worksforme)

Sorry, I need to update my results:

I can reproduce 1 and 2 but not 3, working on it.

#7 - 2019-01-25 05:31 PM - Alessandro Pasotti

- Status changed from Feedback to In Progress

- Affected QGIS version changed from 3.4.4 to 3.5(master)

- Operating System changed from windows 10 to Any

- Pull Request or Patch supplied changed from No to Yes

PR https://github.com/qgis/QGIS/pull/8990

#8 - 2019-01-29 12:09 PM - Alessandro Pasotti

- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Applied in changeset commit:qgis|57d32939363073bafe6d54016813c75c9964adc2.
